import 'package:walletpackage/walletpackage.dart';

Future<void> main() async {
//  testCreateMnemonicAndAddress();
//  testChangePassword();
//  testImportMnemonicAndAddress();

//  testCreateErc20Transaction()
//      .then((value) => {testSignEusdtTransaction(value)});
  testCreateOmniTransaction().then((value) => {testSignUsdtTransaction(value)});

//  testRsa();
}

Future<void> testRsa() async {
  var rsa = await RsaProxy.create();
//  print(rsa.publicKey);
//  print(rsa.privateKey);
  String message = '123456abc';
  String signedText = await rsa.sign(message);
  print(signedText);
  bool verified = await rsa.verifySignature(message, signedText);
  print(verified);
}

Future<void> testSignUsdtTransaction(Object transaction) async {
  String type = 'TUSDT';
  String keystore =
      '{"crypto":{"cipher":"aes-128-ctr","cipherparams":{"iv":"4878f68b566980ace37743781ac45fad"},"ciphertext":"ca189c3911d1e5e14c6706e31dc3736229572c9866eecfef7c6e2a8755fb0fbcc5de0cb299645b446d2d5bc9b2407e617bb6c10a727e06b4dd07f072690c8277","kdf":"scrypt","kdfparams":{"dklen":32,"n":8192,"r":8,"p":1,"salt":"2e0c841f726fcc6b4794c1561a1b4d7ea3d60fa6f73494ba3476e341211fe799"},"mac":"92d5a8b64775db2eeeb70d45683b20016844b2d81a11935c46d047af904c4be4"},"id":"a09a0bba-e9e2-474b-9867-186f48e2dfaa","version":3}';
  String passwd = '12345678';
  String result =
      await WalletProxy.signTransaction(type, keystore, passwd, transaction);
  print(result);
}

Future<Object> testCreateOmniTransaction() async {
  String from = 'mixPwuLD36xxiXEuj8RP2qDqPZWRgdwCat';
  String to = 'mszAS9zTAFHYfYq1X4FP2LubiTPjLKdT8X';
  num value = 0.5;
  num fee = 0.00060333;
  String type = 'TUSDT';
  var transaction = await BitcoinTransaction.createOmniTransaction(
      from, to, value, fee,
      type: type);
  return transaction;
}

Future<void> testSignEusdtTransaction(Object transaction) async {
  String type = 'SIM';
  String keystore =
      '{"crypto":{"cipher":"aes-128-ctr","cipherparams":{"iv":"9229369ffcb7b34bb5edee5d15cefcb2"},"ciphertext":"a383dd63b75ae772a35a324b0dbb1540b6a878f6009418a32e254f0261ab44aab4f0a86ff11cf7df2999e9753dfd8ee0e62e18fc351a3bf9136fc10abc98e36b","kdf":"scrypt","kdfparams":{"dklen":32,"n":8192,"r":8,"p":1,"salt":"d1ccede5158ca825b045a453c3f6b659ee45e14620f06ea936e93731ee9cf80b"},"mac":"71884c7122acadad751d3c54692a4c6145b85df94b572f94a26e93a1e9d5baad"},"id":"121ce5d1-bf44-4bde-a864-5e28c3e6dac6","version":3}';
  String passwd = '12345678';
  String result =
      await WalletProxy.signTransaction(type, keystore, passwd, transaction);
  print(result);
}

Future<Object> testCreateErc20Transaction() async {
  String from = '0x48793114f5e43d190C2ad626406e4a860193084c';
  String to = '0x3db9f46631D1B478004213E4156D6902D73CD202';
  num value = 1.0;
  int gasPrice = 11000000000;
  int nonce = 0;
  String type = 'SIM';
  var transaction = await EthereumTransaction.createErc20Transaction(
      from, to, value, gasPrice, nonce,
      type: type);
  return transaction;
}

Future<void> testImportMnemonicAndAddress() async {
  String mnemonic =
      'diagram frame frequent rain episode convince indoor thank retreat wheat vapor unusual';
  WalletData walletData = await WalletProxy.importMnemonicAndAddress(mnemonic);
  print(walletData.mnemonic);
  print(walletData.keystore);
  print(walletData.addresses);
}

Future<void> testChangePassword() async {
  String keystore =
      '{"crypto":{"cipher":"aes-128-ctr","cipherparams":{"iv":"6c02c795e7b3df21d7b88dee53a3e6bd"},"ciphertext":"658f02c82d551eae5bcec7beb7952d0ad8191f697c6b46e563179c2d8f4868304e08f60c0bd9c566c4aec35091fb4d4502c49f3f1d45d35279af68b84935f563","kdf":"scrypt","kdfparams":{"dklen":32,"n":8192,"r":8,"p":1,"salt":"9bd25b612f58d361b1f69728dc3ee5fe3f22775ddc6a29531111b0be74a6e9b1"},"mac":"c2182716ff042d48d587a727bc9ca338bb27e902ed121acf7b3a9446d9aae0b7"},"id":"0bb8fb48-a218-44b2-97b7-a9d263bb71de","version":3}';
  String passwd = '123456';
  String newPasswd = '456789';
  String newKeystore =
      await WalletProxy.changePassword(keystore, passwd, newPasswd);
  print(newKeystore);
}

Future<void> testCreateMnemonicAndAddress() async {
  WalletData walletData = await WalletProxy.createMnemonicAndAddress('123456');
  print(walletData.mnemonic);
  print(walletData.keystore);
  print(walletData.addresses);
}
